﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;

namespace XamDataGridEnterApp {
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window {

        public ObservableCollection<Element> Items {
            get;
            set;
        }


        public MainWindow() {
            //Items = new ObservableCollection<Element>() {
            //    new Element() { Prop1 = "prop1 value", Prop2 = "prop2 value"},
            //    new Element() { Prop1 = "prop1 value", Prop2 = "prop2 value"},
            //    new Element() { Prop1 = "prop1 value", Prop2 = "prop2 value"},
            //};

            Items = new ObservableCollection<Element>() {
                new Element() { Prop1 = "prop1 value", },
                new Element() { Prop1 = "prop1 value", },
                new Element() { Prop1 = "prop1 value", },
            };





            InitializeComponent();
            MyGrid.EditModeEnded += MyGrid_EditModeEnded;
        }

        void MyGrid_EditModeEnded(object sender, Infragistics.Windows.DataPresenter.Events.EditModeEndedEventArgs e)
        {
            
            bool specialKeyPressed = Keyboard.IsKeyDown(Key.Enter) || Keyboard.IsKeyDown(Key.Tab);
            if (!specialKeyPressed) return;

            //added code
            if (e.Cell.Record.IsAddRecord)
            {
                MyGrid.RecordManager.CommitAddRecord();
            }
            var nextCellAvailable = false; //does not work when we have single column dictionary
            var editModeRes = false;

            do {

                MyGrid.ExecuteCommand(DataPresenterCommands.EndEditModeAndAcceptChanges);
                nextCellAvailable = MyGrid.ExecuteCommand(DataPresenterCommands.CellNext);
                if (!nextCellAvailable) 
                    break;

                editModeRes = MyGrid.ExecuteCommand(DataPresenterCommands.StartEditMode);
            } while (!editModeRes);

        }








    }
}
